<!-- eslint-disable vue/no-multiple-template-root -->
<template>
  <app-circular-loading v-if="!isTelegarmUrl && isServerLoading" />
  <template v-if="isTelegarmUrl">
    <lazy-seo
      :theme-properties="globleStates.stateDataThemeProperties.ThemeProperties"
      :color-config="globleStates.colorConfig"
    />
    <client-only>
      <telegram-login v-if="$route.name === 'telegram-login'"/>
      <telegram-register v-else-if="$route.name === 'telegram-register'"/>
      <nuxt-page v-else :theme="globleStates.themeDirectory" />
    </client-only>
  </template>

  <template v-else-if="globleStates.isSportQr">
    <Link id="stylesheet" rel="stylesheet" type="text/css" :href="globleStates.colorConfig"/>
    <client-only>
      <nuxt-layout>
        <nuxt-page />
      </nuxt-layout>
    </client-only>
  </template>
  <template v-else>
    <lazy-seo
      :theme-properties="globleStates.stateDataThemeProperties.ThemeProperties"
      :color-config="globleStates.colorConfig"
    />
    <client-only>
      <nuxt-layout
        :class="!globleStates.isSportTheme && 'theme-wrapper'"
        :name="globleStates.layout"
        :layout="globleStates.stateThemeName"
        :theme-color="globleStates.themeColor.Text"
        :data-device="isDesktop ? 'desktop' : 'mobile'"
      >
        <nuxt-page :theme="globleStates.themeDirectory" />
      </nuxt-layout>
      <user-center-popup
        v-if="
          globleStates.themeColor.Text === 'bk8_green' ||
          globleStates.themeColor.Text.includes('global') ||
          globleStates.themeColor.Text.includes('playful')
        "
        :layout="globleStates.stateThemeName"
        :theme-color="globleStates.themeColor.Text"
      >
      </user-center-popup>
      <div class="custom-dialog-notification-elementUI">
        <notification-dialog />
      </div>
      <div class="custom-dialog-ads-elementUI">
        <login-advertisement-dialog />
      </div>
      <ads-popup />
      <lobby-sidebar-ads v-if="isDesktop" />
      <right-side-bar-contact-us v-if="isDesktop" />
      <LuckyWheelDialog />
      <icons class="hidden" />
    </client-only>
  </template>
</template>
<script lang="ts" setup>
import _ from "lodash";
import {
  ICompanyThemePropertiesFromApi,
  IThemePropertiesFromApi,
} from "./models/companyThemePropertiesRespone";
import IGetGeography from "./models/geoIpResponse";
import { ILanguage } from "./models/common/language";
import {
  IGame,
  IGetGameProviderListResponse,
  ITabInfo,
} from "./models/IGetPlayableGamesResponse";
import { IGameTypeProviderList } from "./models/bsiGameList";
import { ICurrencies } from "./models/login";
import { IAllCustomerSettingsData } from "./models/getCustomerSettingResponse";
import useInitServerSideConfigSetting from "./composables/config/useInitServerSideConfigSetting";
import useInitClientSideConfigSetting from "./composables/config/useInitClientSideConfigSetting";
import LuckyWheelDialog from "./components/theme/desktop/peru/components/lucky-wheel/LuckyWheelDialog.vue";
import logTracker from "./utils/logTracker";
import { store } from "@/store";
import { EnumSelectedThemeMode } from "./models/enums/enumSelectedThemeMode";

const globleStates = reactive({
  stateDataThemeProperties: useState<ICompanyThemePropertiesFromApi>(),
  homepage: useState<IThemePropertiesFromApi | undefined>(
    KEYS.HOMEPAGE_REDIRECT
  ),
  stateThemeName: useState<String>(KEYS.THEME_NAME),
  themeName: useState<String>(KEYS.ORIGINAL_THEME_NAME),
  stateGeography: useState<IGetGeography>(),
  stateLanguages: useState<ILanguage[]>(),
  stateWebIdByDomian: useState<Number>(KEYS.WEB_ID),
  locale: useCookie<string>(KEYS.LANGUAGE_COOKIE_KEY),
  themeDirectory: useState<string>(),
  colorConfig: useState<string>('color-config'),
  layout: useState<string>(KEYS.LAYOUT),
  currency: useCookie<string>(KEYS.USER_CURRENCY),
  token: useCookie<string>(KEYS.AUTH_COOKIE_KEY),
  isAuth: Boolean(
    useCookie<string>(KEYS.AUTH_COOKIE_KEY).value &&
      useCookie<string>(KEYS.AUTH_COOKIE_KEY).value.length > 0
  ),
  themeColor: themePropertyHelper.themeColor,
  isDesktop: useDevice().isDesktop,
  isUpdateIsImageLess1MBEnabled: useState<boolean>(),
  isPeruShopEnabled: useState<boolean>(KEYS.IS_PERU_SHOP_ENABLED),
  stateTabMenu: useState<ITabInfo[]>(),
  gameProviders: useState<IGetGameProviderListResponse>(),
  gameTabProviders: useState<IGameTypeProviderList>(),
  version: useState<string | undefined>('version'),
  referralEnabled: useState<boolean>(),
  isSportQr: _.includes(_.toLower(useRoute().path), "sport-qr"),
  isIpWhitelistEnabled: useState<boolean>("isIpWhitelistEnabled"),
  isWLAppEnabled: useState<boolean>("isWLAppEnabled"),
  isV2ReferralEnabled: useState<boolean>("isV2ReferralEnabled"),
  isCockfightWhitelist: useState<boolean>("isCockfightWhitelist"),
  fingerPrintLibrary: useState<string>("fingerPrintLibrary"),
  allCurrencies: useState<ICurrencies[]>("allCurrency"),
  allCustomerSettings: useState<IAllCustomerSettingsData[]>(
    KEYS.ALL_CUSTOMER_SETTINGS
  ),
  isShowPeruQr: process.server
    ? false
    : localStorage.getItem("PeruShopEnabled") === "true",
  isSportTheme: useState<String>(KEYS.THEME_NAME).value === "sport",
  domain: commonHelper.getDomain(),
  themePropertiesCdn: commonHelper.getThemePropertiesCdn(),
  ips: useRequestHeaders(["x-forwarded-for"])["x-forwarded-for"],
  xRequestedWith: useRequestHeaders(["x-requested-with"])["x-requested-with"],
  isLandingPage: useState<boolean>("isLandingPage"),
  errorRetryCount: 0,
  selectedThemeMode: process.server
    ? EnumSelectedThemeMode.Light
    : localStorage.getItem("ThemeMode") === "Light" ? EnumSelectedThemeMode.Light : EnumSelectedThemeMode.Dark,
  gtmIdInternal: useState<string>(KEYS.GTM_ID),
  isIndependentModule: useState<boolean>(KEYS.IS_INDEPENDENT_MODULE),
  lightColorConfig: useState<string>("lightColorConfig"),
  darkColorConfig: useState<string>("darkColorConfig"),
  selectedColorConfig: useCookie<string>(KEYS.SELECTED_COLOR_CONFIG),
});
const isServerLoading = useState<boolean>('isServerLoading');
const isPeruShopEnabled = useState<boolean>(KEYS.IS_PERU_SHOP_ENABLED);
const isDesktop = computed(() => {
  if (isPeruShopEnabled.value) return true;
  return useDevice().isDesktop;
})
if (process.server) {
  isServerLoading.value = true;
  if (useRoute().query.isThrowError) {
    throw createError({
      statusCode: 500,
      message: `Error:`,
      fatal: true,
    });
  }
  const { initServerSideConfig } = useInitServerSideConfigSetting(globleStates);
  await initServerSideConfig();
  const { scripts } = useInjectScript(
    globleStates.stateDataThemeProperties.ThemeProperties,
    globleStates,
  );
  useHead(scripts);
  useCookie(KEYS.WEB_ID).value = globleStates.stateWebIdByDomian.toString();
} else {
  // logTracker.error((error: any) => {
  //   fetch(`${window.location.protocol}//${window.location.hostname}/api/log`, {
  //     method: "post",
  //     body: error,
  //   });
  // });
  const { initClientSideConfig } = useInitClientSideConfigSetting(globleStates);
  await initClientSideConfig();
  // const currentSize = document.documentElement.innerHTML.length;
  // console.log(currentSize);
}
const colorState = useState("color-config");
const lightColorState = useState("lightColorConfig");
const DarkColorState = useState("darkColorConfig");
const selectedColorConfig = useCookie<string>(KEYS.SELECTED_COLOR_CONFIG);
if (store.state.selectedThemeName === "global") {
  store.state.selectedThemeMode =
    localStorage.getItem("ThemeMode") === "Light" || localStorage.getItem("ThemeMode") === null
      ? EnumSelectedThemeMode.Light
      : EnumSelectedThemeMode.Dark;

  watch(
    () => store.state.selectedThemeMode,
    () => {
      const stylesheet = document.getElementsByTagName("link")[0];
      if (store.state.selectedThemeMode === EnumSelectedThemeMode.Dark) {
        colorState.value = DarkColorState;
        stylesheet.href = colorState.value;
      } else {
        colorState.value = lightColorState;
        stylesheet.href = colorState.value;
      }
      const colorMode =
        store.state.selectedThemeMode === EnumSelectedThemeMode.Dark
          ? "Dark"
          : "Light";
      localStorage.setItem("ThemeMode", colorMode);
      selectedColorConfig.value = colorMode;
    },
    { immediate: true }
  );
}
const route = useRoute();
const isTelegarmUrl = computed(() =>
  route.name === 'telegram-login'
  || route.query.telegram
  || route.fullPath.includes('/telegram')
);
store.commit("updateIsSwitchComponentCallBefore", false);
const { startMessageInterval } = useMessage();
startMessageInterval();

</script>
<style lang="scss">
html {
  zoom: reset;
  touch-action: manipulation;
}
.custom-elementUI[layout="orange_modern_desktop_1"] {
  .custom-el-select {
    --el-select-close-hover-color: #ffffff;
    .el-input {
      --el-input-placeholder-color: #ffffff;
    }
  }
}
.custom-dialog-ads-elementUI {
  .el-dialog {
    top: 15%;
    .el-dialog__header {
      padding: 0;
    }
    .el-dialog__body {
      padding: 0;
    }
  }
}
.custom-dialog-notification-elementUI {
  .el-dialog {
    top: 15%;
    .el-dialog__header {
      padding: 0;
    }
    .el-dialog__body {
      padding: 0;
      .el-carousel {
        .el-carousel__arrow--left {
          &::after {
            content: "Previous";
          }
          width: auto;
          padding: 8px 15px;
          background-color: #2a437c;
          font-size: 16px;
          border-radius: 4px;
          font-weight: 500;
          top: 86%;
          left: 20%;
          .el-icon {
            display: none;
          }
        }
        .el-carousel__arrow--right {
          &::after {
            content: "Next";
          }
          width: auto;
          padding: 8px 15px;
          background-color: #2a437c;
          font-size: 16px;
          border-radius: 4px;
          font-weight: 500;
          top: 86%;
          right: 42%;
          .el-icon {
            display: none;
          }
        }
        .el-carousel__indicators {
          top: 60%;
          bottom: 30%;
          .el-carousel__button {
            width: 10px;
            height: 10px;
            background-color: #33a3dc;
          }
        }
      }
    }
    .el-button {
      height: 36px;
    }
    .el-button.is-disabled {
      cursor: default;
      background-color: #2a437c;
    }
  }
}
//hide whatapp widget title
.dmopMx {
  display: none;
}
//set whatapp to bottom 64px
[id*="gb-widget-"] {
  bottom: 64px !important;
}

.wallet-page {
  .el-progress.is-exception {
    .el-progress-bar__inner {
      background-color: var(--primary);
    }
  }

  .el-progress-bar__inner {
    display: flex;
    justify-content: flex-start;
    align-items: center;
  }

  .el-progress-bar__innerText {
    margin-left: 8px;
  }

  .el-progress-bar__outer {
    background: var(--border);
  }
}

.wallet-page::-webkit-scrollbar {
  width: 0;
  background-color: transparent;
}

.x-logo {
    width: 20px;
    height: 20px;
    position: relative;
    transform: rotate(45deg);
    cursor: default;

    &::after, &::before {
      content: '';
      position: absolute;
      width: 20px;
      height: 2px;
      top: 50%;
      left: 50%;
      transform: translate(-50%, -50%);
      background-color: var(--textBtn);
      border-radius: 1px;
    }
    &::after {
      transform: translate(-50%, -50%) rotate(90deg);
    }
  }
</style>
<style>
@keyframes ant-skeleton-loading {
  0% {
    transform: translate(-37.5%);
  }
  to {
    transform: translate(37.5%);
  }
}
.theme-wrapper:not([layout="china"])
  .theme-wrapper:not([layout="black"])
  .swiper:not(:has(div.swiper-button-prev))
  .swiper-wrapper {
  justify-content: center;
}
.theme-wrapper:not([layout="china"]) .tab-hover > div {
  overflow: hidden;
}
.theme-wrapper:not([layout="china"]) div:has(> img[lazy="loading"]) {
  position: relative;
  overflow: hidden;
}
.theme-wrapper:not([layout="china"]) div:has(> img[lazy="loading"])::after {
  position: absolute;
  inset: 0 -150%;
  background: linear-gradient(
    90deg,
    rgba(190, 190, 190, 0.2) 25%,
    rgba(129, 129, 129, 0.24) 37%,
    rgba(190, 190, 190, 0.5) 63%
  );
  animation: ant-skeleton-loading 1.4s ease infinite;
  content: "";
}

@-webkit-keyframes stuckMoveDown {
  0% {
    transform: translateY(-100%);
  }

  to {
    transform: translateY(0);
  }
}
@keyframes stuckMoveDown {
  0% {
    transform: translateY(-100%);
  }

  to {
    transform: translateY(0);
  }
}
.header.--animated.sticky {
  -webkit-animation: stuckMoveDown 0.6s;
  animation: stuckMoveDown 0.6s;
  background: var(--background3);
  box-shadow: 0 -6px 10px 5px rgb(0 0 0 / 50%);
  top: 0;
  left: 0;
  margin: 0 auto;
  position: fixed;
  width: 100%;
  z-index: 99;
}
</style>
<style lang="scss">
.el-form-item .el-input__wrapper,
.el-select {
  width: 100%;
}
.el-tooltip__trigger:focus-visible {
  outline: transparent;
}

// TODO: Because it is temporary fix from DESIGN, will modify after fixed from designer
[layout="modern"],
[layout="sbo"],
[layout="china"] {
  .use-new-color-config, .game-disable-container {
    --primary: var(--primary-new);
    --secondary: var(--secondary-new);
    --tertiary: var(--tertiary-new);
    --success: var(--success-new);
    --selected: var(--selected-new);
    --hint: var(--hint-new);
    --failure: var(--failure-new);
    --text: var(--text-new);
    --text2: var(--text2-new);
    --text4: var(--text4-new);
    --text5: var(--text5-new);
    --textBtn: var(--textBtn-new);
    --border: var(--border-new);
    --background1: var(--background1-new);
    --background2: var(--background2-new);
    --background3: var(--background3-new);
    --background4: var(--background4-new);
    --backgroundfb: var(--backgroundfb-new);
    --background5: var(--background5-new);
  }
}
</style>
